package eaa.sorting;

import eaa.sorting.intern.Array;

/**
 * @author Standard
 *
 */
public class MergeSort implements Sorter {

	/**
	 * @see eaa.sorting.Sorter#sort(Array)
	 */
	public void sort(Array a) {
		mergeSort(a, 0, a.size()-1);
	}
	
	public void mergeSort(Array a, int left, int right) {
		if(right > left){
			
			/* Teile und Herrsche, indem die Mitte berechnet wird
			 * und rekursiv fr beide Hlften die Methode
			 * aufgerufen wird.
			 */
			
			int mid = (right + left) / 2;
			mergeSort(a, left, mid);
			mergeSort(a, mid + 1, right);
			
			/* Erstelle einen Hilfscontainer, welcher immer das
			 * kleinere Element ans Ende bekommt, bis einer
			 * der beiden vorherigen Array leer ist.
			 */
			
			Array b = Array.getStorage(right - left);
			int indexb = 0;
			int midIndex = mid +1;
			int leftIndex = left;
			while (leftIndex <= mid && midIndex <= right) {
				if (a.elementAt(leftIndex).isLess(a.elementAt(midIndex))) {
					a.copyTo(leftIndex, b, indexb);
					leftIndex++;
					indexb++;
				} else {
					a.copyTo(midIndex, b, indexb);
					indexb++;
					midIndex++;
				}
			}
			/* Falls der linke Teil leer blieb, dann mssen die
			 * Elemente nach rechts verschoben werden.
			 */
			
			while (leftIndex <= mid) {
				a.swap(leftIndex, right - (mid - leftIndex));
				leftIndex++;
			}
			
			/* Nun muss noch der Rest zurck in den Array.
			 * In b liegt er ja nun sortiert vor.
			 */
			 
			while (indexb > 0) {
				indexb--;
				b.copyTo(indexb, a, left+indexb);
			}
		}
	}

	/**
	 * @see eaa.sorting.Sorter#getInfo()
	 */
	public String getInfo() {
		return "MergeSort";
	}

}
