/* $ Id: $
 * User: kortenka
 * Date: 30.10.2002
 * Time: 00:15:48
 */
package eaa.sorting.intern;

import eaa.sorting.Sorter;
import eaa.sorting.helper.ClassEnumerator;

import java.util.Enumeration;

public class Test {

    public static void runAllSortingAlgorithms(int size) {
        Enumeration classes = ClassEnumerator.getAllClassesImplementing("eaa.sorting.Sorter");
        Array sorted = Array.getSortedArray(size);
        Array reverse = Array.getReverseSortedArray(size);
        Array random = Array.getRandomArray(size);
        Array.resetCounter();

        while (classes.hasMoreElements()) {
            String classname = (String) classes.nextElement();
            runSorter(classname, sorted.getCopy());
            runSorter(classname, reverse.getCopy());
            runSorter(classname, random.getCopy());
        }
    }

    private static void runSorter(String classname, Array a) {
        try {
            Sorter sorter = (Sorter) (Class.forName(classname).newInstance());
            long start = System.currentTimeMillis();
            sorter.sort(a);
            System.out.println(sorter.getInfo() + " -- " + a.getInfo());
            System.out.println("Total cost: " + (Array.getCost() + Element.getCost()) + " Elapsed time: " + ((double)System.currentTimeMillis() - (double)start)/1000 + " seconds");
            System.out.println(Array.stats() + " " + Element.stats());
            System.out.println(a.isSorted()? "Hat korrekt sortiert": "Hat falsch sortiert");
            Array.resetCounter();
            Element.resetCounter();
            System.out.println("--");
        } catch (InstantiationException e) {
            System.err.println("Problem instantiating sorter " + classname);
        } catch (IllegalAccessException e) {
            System.err.println("Illegal access to " + classname);
        } catch (ClassNotFoundException e) {
            System.err.println("Cannot find Sorter " + classname);

        }
    }
}
